/*	zap technologies - copyright 1999
/*	http://www.zaptech.com
/*
/*  1999-03-21 - overhauled for Universal Headers 3.X
/*  1997-08-28 - added some string handling
/*  1997-07-08 - added simple leading space handling
/*  1997-07-02 - created
*/

/*  headers  */
#include <QuickDraw.h>
#include <Windows.h>
#include "myio.h"


/*  local function prototypes  */
void Scroll(WindowPtr wp, char horz);


/*  this routine performs primitive printf() functionality  */
/*  to the stat window directly  */
//  int wprintf(WindowPtr winPtr, char *statstring, char *fmt, ...) {	/*	see K&R stdarg.h for details	*/
int wprintf(wprintDocument *doc, char *fmt, ...) {	/*	see K&R stdarg.h for details	*/
	char *s;
	char *ap;
	char *p;
	char *as;
	char c;
	int ai;
	int al;
	int i, j, rp, op;
	int sp = 0;
	int oldsp = 0;
	int width;
	int length;

//	sp = (doc->bufline)[0];
//	/*  need to MoveTo(sp ...)  */
	sp = 0;
    s = &(doc->bufline)[sp + 1];
	ap = (char *) (&fmt+1);					/*  CAN YOU DIG IT?	*/
	for (p = fmt; *p; p++) {
		switch (*p) {
		  case '%':
			width = 0;
			if (*(p + 1) > '0' && *(p + 1) <= '9')
				width = *++p - '0';
			length = 0;
			if (*(p + 1) == 'l') {  /*  short vs long integers  */
				length = 1;
				p++;
				}
			switch (*++p) {
			  case 's':  /*  null terminated string  */
				as = *((char **) ap)++;
				while (*as) {    /*  DANGER!  */
					if (*as != '\n')
						s[sp++] = *as;
					else {
						s[sp] = 0;
						if (doc->winPtrx) {
							SetPort(doc->winPtrx);
							DrawText(s, 0, sp);
							}
						oldsp = oldsp + sp + 1;
						if (doc->winPtrx)
			  				Scroll(doc->winPtrx, doc->textSize);
		    			sp = 0;
					    s = &(doc->bufline)[1];
						}
					as++;
					}  /*  while (*as)  */
				break;
			  case 'c':  /*  character  */
				s[sp++] = *(*(int **) &ap)++;	/*  THIS IS WACKY!	*/
				break;
			  case 'x':  /*  hexidecimal integer  */
				if (length) {
					al = *(*(long **) &ap)++;	/*  THIS IS WACKY!	*/
					i = 32;
					}
				else {
					i = 16;
					al = *(*(int **) &ap)++;	/*  THIS IS WACKY!	*/
					}
				while (i) {
					i = i - 4;
					c = (al >> i) & 0xF;
					c = c + '0';
					if (c > '9')
						c = c + 'A' - '0' - 10;
					s[sp++] = c;
					}					
				break;
			  case 'd':  /*  integer, 16 bit only for now  */
				ai = *(*(int **) &ap)++;	/*  THIS IS WACKY!	*/
				op = sp;
				if (ai < 0) {
					ai = 0 - ai;
					s[sp++] = '-';
					}
				if (!ai)
					s[sp++] = '0';
				/*  at this point start popping out least significant ascii digits  */
				else {
					rp = sp;
					while (ai) {
						s[sp++] = (ai % 10) + '0';
						ai = ai / 10;
						}
					/*  multi digit numbers, switch digit order to lead with most significant digits  */ 
					j = (sp - rp) >> 1;
					for (i = 0; i < j; i++) {
						c = s[rp + i];
						s[rp + i] = s[sp - 1 - i];
						s[sp - 1 - i] = c;
						}
					}
				/*  process leading space  */
				if (width > (sp - op)) {
					j = width - sp + op;
					while (j--) {
						for (i = sp++; i > op; i--)
							s[i] = s[i - 1];
						s[i] = ' ';
						}
					}
				break;
			  default:
				s[sp++] = '%';
				if (width)
					s[sp++] = '0' + width;
				s[sp++] = *p;
				}  /*  switch %?  */
			break;  /*  %  */
		  case '\n':
			if (sp) {
				s[sp] = 0;
				if (doc->winPtrx) {
					SetPort(doc->winPtrx);
					DrawText(s, 0, sp);
					}
				}
			oldsp = oldsp + sp + 1;
			if (doc->winPtrx)
			    Scroll(doc->winPtrx, doc->textSize + 1);
		    sp = 0;
		    s = &(doc->bufline)[1];
			break;
		  default:
			s[sp++] = *p;
			}  /*  switch %  */
		}  /*  for p  */
    if (sp) {
		s[sp] = 0;
		if (doc->winPtrx) {
			SetPort(doc->winPtrx);
			DrawText(s, 0, sp);
			}
		}
    (doc->bufline)[0] = sp;
	return (sp + oldsp);  /*  return total chars output, including \n  */
	}


void Scroll(WindowPtr wp, char horz) {
	Rect Rect;
	RgnHandle ScrollRegion;

	SetPort(wp);
	Rect = wp->portRect;
	ScrollRegion = NewRgn();
	ScrollRect(&Rect, 0, -horz, ScrollRegion);
	InvalRgn(ScrollRegion);
	DisposeRgn(ScrollRegion);
	MoveTo(wp->portRect.left,wp->portRect.bottom - 3);
	}


/*  returns random value less than limit  */
unsigned short randomLimit(unsigned short m) {
	unsigned short r;

	while ((r = (unsigned short) Random()) >= m);
	return (r);
	}


short strcmp(char *s, char *t) {
	while(*s == *t) {
		if (*s == 0)
			return (0);
		s++;
		t++;
		}
	return (*s - *t);
	}
